{% extends "nav.twig" %}

{% block title %}
	Consultation d'un événement
{% endblock %}

{% block contenu %}
	<a href="{{ app.url_generator.generate('evenements') }}">
		<button class="btn btn-default">
			<i class="glyphicon glyphicon-arrow-left"></i> Retour à la liste
		</button>
	</a>

		{% for event in evenement %}
    <ul class="list-group">
      <li class="list-group-item"> Nom : {{event['nom']}} </li>
      <li class="list-group-item"> Date de début : {{event['date_debut']}} </li>
      <li class="list-group-item"> Date de fin : {{event['date_fin']}} </li>
      <li class="list-group-item"> Enseignant responsable : {{enseignant[event['enseignant']]}} </li>
      <li class="list-group-item"> Groupe : {{groupe[event['groupe']]}} </li>
      <li class="list-group-item"> Durée des soutenances : {{event['dureeSoutenances']}} minutes </li>
		</ul>

    <button type="button" class="btn btn-primary" onclick="show()" id="show"> Attribuer groupe </button>

		<div id="add" class="">
      <br/>
			<form method="post" action="{{ app.url_generator.generate('ajout_slot') }}" class="top_margin">
	      <div class="form-group row">
	  			<label for="staticGroupe" class="col-sm-4 col-form-label"> Groupe de soutenance </label>
	  			<div class="col-sm-8">
	          <select class="form-control" id="staticGroupe" name="groupe" required>
	            {% for groupe in groupesoutenance %}
	              <option value="{{groupe.id}}"> {{groupe.nom}} </option>
	            {% endfor %}
	          </select>
	        </div>
	      </div>

				<div class="form-group row">
	  			<label for="staticDate" class="col-sm-4 col-form-label"> Date de passage </label>
	  			<div class="col-sm-8">
	          <select class="form-control" id="staticDate" name="date" required>

	          </select>
	        </div>
	      </div>

				<div class="form-group row">
	  			<label for="staticSalle" class="col-sm-4 col-form-label"> Salle </label>
	  			<div class="col-sm-8">
	          <select class="form-control" id="staticSalle" name="salle" required>
							<option value="i03"> i03 </option>
							<option value="i07"> i07 </option>
							<option value="i12"> i12 </option>
							<option value="i21"> i21 </option>
							<option value="i22"> i22 </option>
							<option value="i23"> i23 </option>
							<option value="i24"> i24 </option>
							<option value="i25"> i25 </option>
							<option value="i26"> i26 </option>
							<option value="i27"> i27 </option>
	          </select>
	        </div>
	      </div>

				<div class="form-group row">
	  			<label for="staticHeure" class="col-sm-4 col-form-label"> Heure de début </label>
	  			<div class="col-sm-8">
	          <input type="text" class="form-control" id="staticHeure" name="heure" placeholder="Heure début (ex: 08:20)" pattern="([01]?[0-9]{1}|2[0-3]{1}):[0-5]{1}[0-9]{1}" required/>
	        </div>
	      </div>

				<input type="hidden" name="heure_fin" id="heurefin"/>
				<input type="hidden" name="id_event" value="{{event.id}}"/>
				<input type="hidden" name="enseignant" value="{{enseignant[event['enseignant']]}}"/>
				<button type="button" class="btn btn-success" onclick="calc()" id="sub"> <i class="glyphicon glyphicon-ok"></i> Ajouter </button>
			</form>
    </div>

		<h3> Liste des soutenances </h3>
		{% if slots != '' %}
			{% for slot in slots %}
				<ul class="list-group">
		      <li class="list-group-item"> Date : {{slot['date']}} </li>
					<li class="list-group-item"> Heure de début : {{slot['heure_debut']}} </li>
					<li class="list-group-item"> Heure de fin : {{slot['heure_fin']}} </li>
					<li class="list-group-item"> Salle : {{slot['salle']}} </li>
					<li class="list-group-item"> Enseignant : {{slot['enseignant']}} </li>
					<li class="list-group-item"> Groupe de soutenance : {{groupes_soutenances[soutenance[slot['id']]]}} </li>
					<li class="list-group-item"> <a href="{{ app.url_generator.generate('suppr_slot', {'id': slot['id']}) }}" class="btn btn-danger"> <i class="glyphicon glyphicon-trash"></i> Supprimer </a> </li>
				</ul>
			{% endfor %}
		{% endif %}

		<script>
		function show() {
			if($("#add").hasClass("hidden")) {
				$("#add").removeClass("hidden");
				$("#show").text("Fermer");
			}
			else {
				$("#add").addClass("hidden");
				$("#show").text("Attribuer groupe");
			}
		}

		window.onload = function() {
			$("#add").addClass("hidden");
			let debut = "{{event.date_debut}}";
			let deb = new Date();
			deb.setFullYear(debut.substr(0,4));
			deb.setMonth(parseInt(debut.substr(5,2))-1);
			deb.setDate(debut.substr(8,2));
			deb.setHours(0);
			deb.setMinutes(0);
			deb.setSeconds(0);
			deb.setMilliseconds(0);
			let start=deb.getTime(); // date de début en nombre
			let day = "";
			if(deb.getDate() < 10) {
				day = "0"+deb.getDate();
			}
			else {
				day = deb.getDate();
			}
			if(deb.getMonth() < 10) {
				$("#staticDate").append($("<option>", {
					value: deb.getFullYear()+"-0"+(deb.getMonth()+1)+"-"+day,
					text: day+"/0"+(deb.getMonth()+1)+"/"+deb.getFullYear()
				}));
			}
			else {
				$("#staticDate").append($("<option>", {
					value: deb.getFullYear()+"-"+(deb.getMonth()+1)+"-"+deb.getDate(),
					text: deb.getDate()+"/"+(deb.getMonth()+1)+"/"+deb.getFullYear()
				}));
			}

			let fin = "{{event.date_fin}}";
			let fi = new Date();
			fi.setFullYear(fin.substr(0,4));
			fi.setMonth(parseInt(fin.substr(5,2))-1);
			fi.setDate(fin.substr(8,2));
			fi.setHours(0);
			fi.setMinutes(0);
			fi.setSeconds(0);
			fi.setMilliseconds(0);
			let end=fi.getTime(); // date de fin

			let prec = "";

			let again = true;

			while(again) {
				if(prec == "") {
					let next = new Date();
					next.setFullYear(deb.getFullYear());
					next.setMonth(deb.getMonth());
					next.setDate(deb.getDate()+1); // jour d'après
					prec = next;
					if(next.getDate() < 10) {
						day = "0"+next.getDate();
					}
					else {
						day = next.getDate();
					}
					if(next.getTime() < end) {
						if(deb.getMonth() < 10) {
							$("#staticDate").append($("<option>", {
								value: next.getFullYear()+"-0"+(next.getMonth()+1)+"-"+day,
								text: day+"/0"+(next.getMonth()+1)+"/"+next.getFullYear()
							}));
						}
						else {
							$("#staticDate").append($("<option>", {
								value: next.getFullYear()+"-"+(next.getMonth()+1)+"-"+day,
								text: day+"/"+(next.getMonth()+1)+"/"+next.getFullYear()
							}));
						}
					}
					else {
						again = false;
					}
				}
				else {
					let next = new Date();
					next.setFullYear(prec.getFullYear());
					next.setMonth(prec.getMonth());
					next.setDate(prec.getDate()+1); // jour d'après
					prec = next;
					if(next.getDate() < 10) {
						day = "0"+next.getDate();
					}
					else {
						day = next.getDate();
					}
					if(next.getTime() < end) {
						if(deb.getMonth() < 10) {
							$("#staticDate").append($("<option>", {
								value: next.getFullYear()+"-0"+(next.getMonth()+1)+"-"+day,
								text: day+"/0"+(next.getMonth()+1)+"/"+next.getFullYear()
							}));
						}
						else {
							$("#staticDate").append($("<option>", {
								value: next.getFullYear()+"-"+(next.getMonth()+1)+"-"+day,
								text: day+"/"+(next.getMonth()+1)+"/"+next.getFullYear()
							}));
						}
					}
					else {
						again = false;
					}
				}
			}

			if(deb.getTime() != fi.getTime()) {
				if(fi.getDate() < 10) {
					day = "0"+fi.getDate();
				}
				else {
					day = fi.getDate();
				}
				if(fi.getMonth() < 10) {
					$("#staticDate").append($("<option>", {
						value: fi.getFullYear()+"-0"+(fi.getMonth()+1)+"-"+day,
						text: day+"/0"+(fi.getMonth()+1)+"/"+fi.getFullYear()
					}));
				}
				else {
					$("#staticDate").append($("<option>", {
						value: fi.getFullYear()+"-"+(fi.getMonth()+1)+"-"+day,
						text: day+"/"+(fi.getMonth()+1)+"/"+fi.getFullYear()
					}));
				}
			}
		}

		function calc() {
			let debut = $("#staticHeure").val();
			let regex = /([01]?[0-9]{1}|2[0-3]{1}):[0-5]{1}[0-9]{1}/i;
			if(regex.test(debut)) { // si le format de l'heure est le bon
				let deb = new Date();
				let splited = debut.split(":");
				let duree = "{{event.dureeSoutenances}}"
				duree = parseInt(duree);
				deb.setHours(splited[0]);
				deb.setMinutes(splited[1]);
				deb.setMinutes(deb.getMinutes()+duree); // heure de fin
				let fin = (deb.getHours()<10?'0':'') + deb.getHours()+":"+(deb.getMinutes()<10?'0':'') + deb.getMinutes(); // heure sous le bon format
				$("#heurefin").val(fin);
				$("#sub").attr("type", "submit");
				$("#sub").click();
			}
			else {
				$("#sub").attr("type", "submit");
				$("#sub").click();
				$("#sub").attr("type", "button");
			}
		}
		</script>
		{% endfor %}
{% endblock %}
